﻿using System;
using System.CodeDom.Compiler;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Mail;
using System.Reflection;
using System.Runtime.CompilerServices;
using System.Text;
using System.Text.Json;
using System.Text.RegularExpressions;
using System.Threading;
using System.Threading.Tasks;
using System.Web.Script.Serialization;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Interop;
using System.Windows.Markup;
using System.Windows.Media;
using System.Windows.Navigation;
using System.Windows.Threading;
using HtmlAgilityPack;
using Microsoft.CSharp.RuntimeBinder;
using Microsoft.SharePoint.Client;
using mshtml;
using ZionRobot.Helpers;
using ZionRobot.Models.AASP;
using ZionRobot.Models.Items;
using ZionRobot.Models.Search;
using ZionRobot.Models.Source;
using ZionRobot.Models.ZFlow;
using ZionRobot.Persistence;
using ZionRobot.ZionExchangeManagement;
using ZionVault.Binder.OCR;
using ZionVault.WebService;

namespace ZionRobot.Handlers
{
	// Token: 0x0200003B RID: 59
	public partial class Browser : Window
	{
		// Token: 0x170000E5 RID: 229
		// (get) Token: 0x0600023A RID: 570 RVA: 0x00008D40 File Offset: 0x00006F40
		public static Browser Instance
		{
			get
			{
				bool flag = Browser.instance == null;
				if (flag)
				{
					Browser.instance = new Browser();
				}
				return Browser.instance;
			}
		}

		// Token: 0x170000E6 RID: 230
		// (get) Token: 0x0600023B RID: 571 RVA: 0x00008D6D File Offset: 0x00006F6D
		public Thread Main
		{
			get
			{
				return this.main;
			}
		}

		// Token: 0x170000E7 RID: 231
		// (get) Token: 0x0600023C RID: 572 RVA: 0x00008D75 File Offset: 0x00006F75
		public bool Terminate
		{
			get
			{
				return this.terminate;
			}
		}

		// Token: 0x170000E8 RID: 232
		// (get) Token: 0x0600023D RID: 573 RVA: 0x00008D7D File Offset: 0x00006F7D
		// (set) Token: 0x0600023E RID: 574 RVA: 0x00008D85 File Offset: 0x00006F85
		public Origin Source
		{
			get
			{
				return this.source;
			}
			set
			{
				this.source = value;
			}
		}

		// Token: 0x170000E9 RID: 233
		// (get) Token: 0x0600023F RID: 575 RVA: 0x00008D8E File Offset: 0x00006F8E
		// (set) Token: 0x06000240 RID: 576 RVA: 0x00008D96 File Offset: 0x00006F96
		public Dictionary<string, string> DictionaryValues
		{
			get
			{
				return this.dictionaryValues;
			}
			set
			{
				this.dictionaryValues = value;
			}
		}

		// Token: 0x170000EA RID: 234
		// (get) Token: 0x06000241 RID: 577 RVA: 0x00008D9F File Offset: 0x00006F9F
		// (set) Token: 0x06000242 RID: 578 RVA: 0x00008DA7 File Offset: 0x00006FA7
		public List<List<Element>> SearchElements
		{
			get
			{
				return this.searchElements;
			}
			set
			{
				this.searchElements = value;
			}
		}

		// Token: 0x06000243 RID: 579 RVA: 0x00008DB0 File Offset: 0x00006FB0
		public Browser()
		{
			this.InitializeComponent();
			base.Closing += this.Browser_Closing;
			DockPanel parent = this._holder;
			WebBrowser replacement = new WebBrowser();
			replacement.Name = "browser";
			parent.Children.Clear();
			parent.Children.Add(replacement);
			this.browser = null;
			this.browser = replacement;
			this.browser.VerticalAlignment = VerticalAlignment.Stretch;
			this.browser.HorizontalAlignment = HorizontalAlignment.Stretch;
			this.browser.Navigating += this.Browser_Navigating;
			this.browser.LoadCompleted += this.Browser_LoadComplete;
			this.browser.Unloaded += this.Browser_Unloaded;
			this.HideScriptErrors(this.browser, true);
			this.dictionaryValues = new Dictionary<string, string>();
			this.searchElements = new List<List<Element>>();
		}

		// Token: 0x06000244 RID: 580 RVA: 0x00008EB4 File Offset: 0x000070B4
		private void Browser_Unloaded(object sender, RoutedEventArgs e)
		{
			this.browser.ContextMenu = null;
			this.browser.DataContext = null;
			this.browser.Resources = null;
			this.browser.Source = null;
			this.browser.Navigating -= this.Browser_Navigating;
			this.browser.LoadCompleted -= this.Browser_LoadComplete;
			this.browser.Unloaded -= this.Browser_Unloaded;
			this.browser.Dispose();
		}

		// Token: 0x06000245 RID: 581 RVA: 0x00008F4C File Offset: 0x0000714C
		private void Browser_Closing(object sender, CancelEventArgs e)
		{
			this.terminate = true;
			this.Dispose();
			this.main = null;
			this.source = null;
			this.dictionaryValues.Clear();
			this.dictionaryValues = null;
			this.searchElements.Clear();
			this.searchElements = null;
			Browser.instance = null;
			GC.SuppressFinalize(this);
			GC.Collect();
			GC.WaitForPendingFinalizers();
			GC.Collect();
		}

		// Token: 0x06000246 RID: 582 RVA: 0x00008FBC File Offset: 0x000071BC
		public void Dispose()
		{
			this.main.Abort();
			BindingOperations.ClearAllBindings(this.browser);
			Window w = Browser.getWindowElement(this.browser);
			FieldInfo field = typeof(Window).GetField("_swh", BindingFlags.Instance | BindingFlags.NonPublic);
			object valueSWH = field.GetValue(this);
			object valueSourceWindow = valueSWH.GetType().GetField("_sourceWindow", BindingFlags.Instance | BindingFlags.NonPublic).GetValue(valueSWH);
			object valueKeyboardInput = valueSourceWindow.GetType().GetField("_keyboardInputSinkChildren", BindingFlags.Instance | BindingFlags.NonPublic).GetValue(valueSourceWindow);
			IEnumerable<IKeyboardInputSite> inputSites = valueKeyboardInput as IEnumerable<IKeyboardInputSite>;
			bool flag = inputSites == null;
			if (!flag)
			{
				IKeyboardInputSite currentSite = inputSites.FirstOrDefault((IKeyboardInputSite s) => s.Sink == this.browser);
				bool flag2 = currentSite != null;
				if (flag2)
				{
					currentSite.Unregister();
				}
				this._holder.Children.Remove(this.browser);
			}
		}

		// Token: 0x06000247 RID: 583 RVA: 0x00009098 File Offset: 0x00007298
		private static Window getWindowElement(DependencyObject element)
		{
			while (element != null && !(element is Window))
			{
				element = VisualTreeHelper.GetParent(element);
			}
			return element as Window;
		}

		// Token: 0x06000248 RID: 584 RVA: 0x000090D2 File Offset: 0x000072D2
		private void Browser_Navigating(object sender, NavigatingCancelEventArgs e)
		{
			this.wait = true;
			Console.WriteLine(e.Uri);
		}

		// Token: 0x06000249 RID: 585 RVA: 0x000090E8 File Offset: 0x000072E8
		private void Browser_LoadComplete(object sender, NavigationEventArgs e)
		{
			this.wait = false;
		}

		// Token: 0x0600024A RID: 586 RVA: 0x000090F4 File Offset: 0x000072F4
		private void Browser_LayoutUpdated(object sender, EventArgs e)
		{
			HTMLDocument doc = (HTMLDocument)this.browser.Document;
			this.browser.LayoutUpdated -= this.Browser_LayoutUpdated;
		}

		// Token: 0x0600024B RID: 587 RVA: 0x00009130 File Offset: 0x00007330
		private void HideScriptErrors(WebBrowser wb, bool hide)
		{
			FieldInfo fiComWebBrowser = typeof(WebBrowser).GetField("_axIWebBrowser2", BindingFlags.Instance | BindingFlags.NonPublic);
			bool flag = fiComWebBrowser == null;
			if (!flag)
			{
				object objComWebBrowser = fiComWebBrowser.GetValue(wb);
				bool flag2 = objComWebBrowser == null;
				if (flag2)
				{
					wb.Loaded += delegate(object o, RoutedEventArgs s)
					{
						this.HideScriptErrors(wb, hide);
					};
				}
				else
				{
					objComWebBrowser.GetType().InvokeMember("Silent", BindingFlags.SetProperty, null, objComWebBrowser, new object[]
					{
						hide
					});
				}
			}
		}

		// Token: 0x0600024C RID: 588 RVA: 0x000091DC File Offset: 0x000073DC
		private void Wait()
		{
			while (this.wait)
			{
				Thread.Sleep(1000);
			}
		}

		// Token: 0x0600024D RID: 589 RVA: 0x00009204 File Offset: 0x00007404
		public void CreateLawsuit(Lawsuit lawsuit)
		{
			Application.Current.Dispatcher.Invoke(delegate()
			{
				this.Visibility = Visibility.Visible;
				this.ShowInTaskbar = true;
				this.Show();
				this.terminate = false;
			});
			Action<KeyValuePair<string, string>> <>9__3;
			this.main = new Thread(delegate()
			{
				List<ZionRobot.Models.Source.Action> UpdateActivityActions = (from be in this.Source.BlockElements
				where be.Name == "CreateLawsuit"
				select be).FirstOrDefault<BlockElement>().Actions;
				List<KeyValuePair<string, string>> list = lawsuit.Fields.ToList<KeyValuePair<string, string>>();
				Action<KeyValuePair<string, string>> action2;
				if ((action2 = <>9__3) == null)
				{
					action2 = (<>9__3 = delegate(KeyValuePair<string, string> f)
					{
						string value = f.Value;
						DateTime date;
						this.dictionaryValues.Add(f.Key, DateTime.TryParse(f.Value, out date) ? Shift.formatDate(f.Value, "dd/MM/yyyy", "pt-BR") : f.Value);
					});
				}
				list.ForEach(action2);
				this.dictionaryValues.Add("Adverse_name", lawsuit.Adverse.Name.ToString());
				this.dictionaryValues.Add("Adverse_juridical_person", lawsuit.Adverse.Juridical_person.ToString());
				this.dictionaryValues.Add("Accountable", lawsuit.Accountable);
				this.dictionaryValues.Add("Folder_number", lawsuit.Folder_number);
				this.dictionaryValues.Add("Opening_date", Shift.formatDate(lawsuit.Opening_date.ToString(), "dd/MM/yyyy", "pt-BR"));
				this.dictionaryValues.Add("Distribution_date", Shift.formatDate(lawsuit.Distribution_date.ToString(), "dd/MM/yyyy", "pt-BR"));
				this.dictionaryValues.Add("Client", lawsuit.Client);
				this.dictionaryValues.Add("Field_of_law", lawsuit.Field_of_law);
				this.dictionaryValues.Add("Subject", lawsuit.Subject);
				foreach (ZionRobot.Models.Source.Action action in UpdateActivityActions)
				{
					Task<bool> task = this.executeAction(action);
					task.Wait();
					bool execute = task.Result;
				}
				bool flag = this.dictionaryValues.ContainsKey("Lawsuit_link");
				if (flag)
				{
					lawsuit.Link = this.dictionaryValues["Lawsuit_link"];
					lawsuit.UpdateUrl();
					lawsuit.UpdateSycn(2);
				}
				else
				{
					lawsuit.UpdateSycn(5);
				}
			});
			this.Main.Start();
		}

		// Token: 0x0600024E RID: 590 RVA: 0x00009268 File Offset: 0x00007468
		public void ExecuteAndSave(string path)
		{
			Application.Current.Dispatcher.Invoke(delegate()
			{
				this.Visibility = Visibility.Visible;
				this.ShowInTaskbar = true;
				this.Show();
				this.terminate = false;
			});
			this.main = new Thread(delegate()
			{
				foreach (ActionsElement actionElement in this.Source.ActionsElements)
				{
					foreach (ZionRobot.Models.Source.Action action in actionElement.Actions)
					{
						this.executeAction(action).Wait();
					}
				}
				this.SaveData(path);
			});
			this.main.Start();
		}

		// Token: 0x0600024F RID: 591 RVA: 0x000092CC File Offset: 0x000074CC
		private void SaveData(string path)
		{
			this.searchElements.ForEach(delegate(List<Element> data)
			{
				string allElementsTxt = string.Join(" ", (from d in data
				where d.GoTo == "SearchLog"
				select d into e
				select e.Value).ToArray<string>());
				bool flag = !this.hasLog(allElementsTxt);
				if (flag)
				{
					DateTime datenow = DateTime.Now;
					string fileName = string.Format("Publicação-{0}-{1}", this.source.OutputFolder, datenow.ToString("yyyyMMdd-HHmmssffff"));
					Document doc = new Document();
					doc.Pages.Add(new ZionVault.Binder.OCR.Page(string.Join(Environment.NewLine, (from d in data
					where d.GoTo == "Meta"
					select d into e
					select e.Value).ToArray<string>())));
					Directory.CreateDirectory(path);
					string fileFullPath = Naming.GetFileFullPath(path, fileName, ".ocr");
					doc.Save(fileFullPath, false, false);
					CultureInfo culture = new CultureInfo("pt-BR");
					Logs.SearchLog.SearchResults.Add(string.Concat(new string[]
					{
						datenow.ToString("G", culture),
						"||",
						this.source.Title,
						"||",
						fileFullPath,
						"||",
						allElementsTxt
					}));
					Logs.SearchLog.Save();
				}
			});
		}

		// Token: 0x06000250 RID: 592 RVA: 0x00009308 File Offset: 0x00007508
		public void ExecuteAndMove(ZionRobot.Models.Items.File file, string outputPath)
		{
			Application.Current.Dispatcher.Invoke(delegate()
			{
				this.Visibility = Visibility.Visible;
				this.ShowInTaskbar = true;
				this.Show();
				this.terminate = false;
			});
			this.main = new Thread(delegate()
			{
				foreach (ActionsElement actionElement in this.Source.ActionsElements)
				{
					foreach (ZionRobot.Models.Source.Action action in actionElement.Actions)
					{
						Task<bool> task = this.executeAction(action);
						task.Wait();
						bool execute = task.Result;
					}
				}
				Activity activity = new Activity();
				activity.Date = this.dictionaryValues["ActivityDate"];
				activity.DateFinal = this.dictionaryValues["ActivityDate"];
				activity.TypeId = 152;
				activity.Subject = "Verificar";
				activity.Client = this.dictionaryValues["Cliente"];
				activity.Sponsor = this.dictionaryValues["userName"];
				activity.Fields.Add("1", activity.Sponsor);
				activity.Fields.Add("2", activity.Client);
				activity.Fields.Add("3", this.dictionaryValues["Número da pasta"]);
				activity.Fields.Add("4", this.dictionaryValues["URL da atividade"]);
				activity.Fields.Add("5", (this.dictionaryValues.FirstOrDefault((KeyValuePair<string, string> x) => x.Key == "ProcessUrl").Key != null) ? this.dictionaryValues["ProcessUrl"] : "");
				activity.Fields.Add("6", (this.dictionaryValues.FirstOrDefault((KeyValuePair<string, string> x) => x.Key == "SharpointUrl").Key != null) ? this.dictionaryValues["SharpointUrl"] : "");
				activity.Fields.Add("7", Shift.formatDate(this.dictionaryValues["Data da publicação"], "yyyy-MM-dd HH:mm:ss", "pt-BR"));
				activity.Fields.Add("9", this.dictionaryValues["SearchElements.Fields.ConteudoCompleto"]);
				activity.Fields.Add("10", (this.dictionaryValues.FirstOrDefault((KeyValuePair<string, string> x) => x.Key == "Parecer").Key != null) ? this.dictionaryValues["Parecere"] : "");
				try
				{
					activity.createActivity();
				}
				catch (Exception ex)
				{
				}
				finally
				{
					file.METAObject.Status = "INTEGRATED";
					file.METAObject.Save(file.META, false, false);
					file.Status = "INTEGRATED";
				}
			});
			this.Main.Start();
		}

		// Token: 0x06000251 RID: 593 RVA: 0x0000936C File Offset: 0x0000756C
		public void SyncActivity(Activity activity)
		{
			Application.Current.Dispatcher.Invoke(delegate()
			{
				this.Visibility = Visibility.Visible;
				this.ShowInTaskbar = true;
				this.Show();
				this.terminate = false;
			});
			this.main = new Thread(delegate()
			{
				bool execute = true;
				this.DictionaryValues.Add("ActivityUrl", activity.DataJuri);
				this.DictionaryValues.Add("Responsável", activity.Sponsor);
				this.DictionaryValues.Add("EmailResponsável", activity.SponsorEmail);
				this.DictionaryValues.Add("Cliente", activity.Client);
				this.DictionaryValues.Add("NumeroPasta", activity.ProcessNumber);
				this.DictionaryValues.Add("Data", Shift.formatDate(activity.Date, "dd/MM/yyyy", "pt-BR"));
				this.DictionaryValues.Add("DataFatal", Shift.formatDate(activity.DateFinal, "dd/MM/yyyy", "pt-BR"));
				foreach (ActionsElement actionElement in this.Source.ActionsElements)
				{
					foreach (ZionRobot.Models.Source.Action action in actionElement.Actions)
					{
						Task<bool> task = this.executeAction(action);
						task.Wait();
						execute = task.Result;
					}
				}
				bool flag = activity.Parecer != null && activity.TypeId == 1;
				if (flag)
				{
					this.DictionaryValues.Add("ActivityParecer", activity.Parecer);
					List<ZionRobot.Models.Source.Action> createParecerActions = (from be in this.Source.BlockElements
					where be.Name == "CreateParecer"
					select be).FirstOrDefault<BlockElement>().Actions;
					bool flag2 = createParecerActions != null;
					if (flag2)
					{
						foreach (ZionRobot.Models.Source.Action action2 in createParecerActions)
						{
							Task<bool> task2 = this.executeAction(action2);
							task2.Wait();
							execute = task2.Result;
						}
					}
				}
				List<ZionRobot.Models.Source.Action> createCommentActions = (from be in this.Source.BlockElements
				where be.Name == "CreateComment"
				select be).FirstOrDefault<BlockElement>().Actions;
				bool flag3 = createCommentActions != null;
				if (flag3)
				{
					(from c in activity.Comments
					orderby c.CreatedAt
					select c).ToList<Comment>().ForEach(delegate(Comment comment)
					{
						this.DictionaryValues.Add("CommentResponser", comment.CreatedByName);
						this.DictionaryValues.Add("CommentSubject", comment.Subject);
						this.DictionaryValues.Add("CommentValue", comment.Value);
						foreach (ZionRobot.Models.Source.Action action4 in createCommentActions)
						{
							Task<bool> task4 = this.executeAction(action4);
							task4.Wait();
							execute = task4.Result;
						}
						this.DictionaryValues.Remove("CommentResponser");
						this.DictionaryValues.Remove("CommentSubject");
						this.DictionaryValues.Remove("CommentValue");
					});
				}
				List<ZionRobot.Models.Source.Action> createDeadlineActions = (from be in this.Source.BlockElements
				where be.Name == "CreateDeadline"
				select be).FirstOrDefault<BlockElement>().Actions;
				activity.Deadlines.ForEach(delegate(Deadline deadline)
				{
					bool flag5 = createDeadlineActions != null;
					if (flag5)
					{
						this.DictionaryValues.Add("DeadlineResponser", deadline.SponserName);
						this.DictionaryValues.Add("DeadlineResponserEmail", deadline.SponserEmail);
						this.DictionaryValues.Add("DeadlineSubject", deadline.Subject);
						this.DictionaryValues.Add("DeadlineDate", Shift.formatDate(deadline.Pre, "dd/MM/yyyy", "pt-BR"));
						this.DictionaryValues.Add("DeadlineFinal", Shift.formatDate(deadline.Value, "dd/MM/yyyy", "pt-BR"));
						this.DictionaryValues.Add("SearchElements.Fields.Tipo", "Publicação");
						foreach (ZionRobot.Models.Source.Action action4 in createDeadlineActions)
						{
							Task<bool> task4 = this.executeAction(action4);
							task4.Wait();
							execute = task4.Result;
						}
						Activity subActivity = new Activity();
						subActivity.EntityId = activity.EntityId;
						subActivity.ParentId = new int?(activity.Id);
						subActivity.Date = this.dictionaryValues["DeadlineDate"];
						subActivity.DateFinal = this.dictionaryValues["DeadlineFinal"];
						subActivity.TypeId = 4;
						subActivity.Subject = this.dictionaryValues["DeadlineSubject"];
						subActivity.Client = this.dictionaryValues["Cliente"];
						subActivity.Sponsor = this.dictionaryValues["DeadlineResponser"];
						subActivity.Fields.Add("1", subActivity.Client);
						subActivity.Fields.Add("2", subActivity.Sponsor);
						subActivity.Fields.Add("3", (!string.IsNullOrEmpty(activity.ProcessNumber)) ? activity.ProcessNumber : "");
						subActivity.Fields.Add("4", this.dictionaryValues["URL da atividade"]);
						subActivity.Fields.Add("5", (activity.ProcessURL != null) ? activity.ProcessURL : "");
						subActivity.Fields.Add("6", (activity.Sharepoint != null) ? activity.Sharepoint : "");
						subActivity.createActivity();
						this.DictionaryValues.Remove("DeadlineResponser");
						this.DictionaryValues.Remove("DeadlineResponserEmail");
						this.DictionaryValues.Remove("DeadlineSubject");
						this.DictionaryValues.Remove("DeadlineDate");
						this.DictionaryValues.Remove("DeadlineFinal");
						this.DictionaryValues.Remove("SearchElements.Fields.Tipo");
						this.DictionaryValues.Remove("Número da pasta");
						this.DictionaryValues.Remove("URL da atividade");
						this.DictionaryValues.Remove("1");
						this.DictionaryValues.Remove("2");
						this.DictionaryValues.Remove("3");
						this.DictionaryValues.Remove("4");
						this.DictionaryValues.Remove("5");
						this.DictionaryValues.Remove("6");
					}
				});
				List<ZionRobot.Models.Source.Action> doneActivityActions = (from be in this.Source.BlockElements
				where be.Name == "DoneActivity"
				select be).FirstOrDefault<BlockElement>().Actions;
				bool flag4 = doneActivityActions != null;
				if (flag4)
				{
					foreach (ZionRobot.Models.Source.Action action3 in doneActivityActions)
					{
						Task<bool> task3 = this.executeAction(action3);
						task3.Wait();
						execute = task3.Result;
					}
				}
				activity.DoneActivity();
			});
			this.Main.Start();
		}

		// Token: 0x06000252 RID: 594 RVA: 0x000093D0 File Offset: 0x000075D0
		public void OldUploadAttachments(Activity activity)
		{
			Application.Current.Dispatcher.Invoke(delegate()
			{
				this.Visibility = Visibility.Visible;
				this.ShowInTaskbar = true;
				this.Show();
				this.terminate = false;
			});
			this.main = new Thread(delegate()
			{
				string clientFolder = (activity.ClientCode != null) ? (activity.ClientCode + " " + activity.Client) : activity.Client;
				string numberFolder = "Consultas/" + clientFolder + "/" + activity.ProcessNumber;
				string attachmentsFolder = (activity.Action == "Sharepoint") ? "Anexos Recebidos" : "Anexos Enviados";
				string subDir = (activity.Attachments.Count<ZionRobot.Models.ZFlow.Attachment>() == 0) ? numberFolder : (numberFolder + "/" + attachmentsFolder);
				ZionSharePointManager manager = new ZionSharePointManager(SoaresPiconSharePoint.UserName, SoaresPiconSharePoint.Password);
				manager.ConnectToSharePointOnline(SoaresPiconSharePoint.ConsultaUrl);
				List collection = manager.GetCollection("Documentos");
				Microsoft.SharePoint.Client.Folder folder = manager.GetFolder(collection, subDir.Trim(new char[]
				{
					'/'
				}));
				bool flag = folder.Name != subDir.Split(new char[]
				{
					'/'
				}).Last<string>() || !folder.Name.StartsWith(subDir.Split(new char[]
				{
					'/'
				}).Last<string>());
				if (flag)
				{
					folder = manager.BuildFolder(collection, subDir);
				}
				Microsoft.SharePoint.Client.File file;
				foreach (ZionRobot.Models.ZFlow.Attachment attach in activity.Attachments)
				{
					file = manager.UploadFile(folder, attach.Name, attach.Content);
					bool flag2 = file == null;
					if (flag2)
					{
						activity.UpdateActivitySycn(3);
						return;
					}
					attach.Link = new Uri(SoaresPiconSharePoint.SiteUrl + file.ServerRelativeUrl);
					attach.UpdateLinkOnZion();
				}
				bool flag3 = folder.Name != numberFolder.Split(new char[]
				{
					'/'
				}).Last<string>() || !folder.Name.StartsWith(numberFolder.Split(new char[]
				{
					'/'
				}).Last<string>());
				if (flag3)
				{
					folder = manager.GetFolder(collection, numberFolder);
				}
				HtmlDocument htmlDoc = new HtmlDocument();
				htmlDoc.LoadHtml(activity.EmailContent);
				string result = htmlDoc.DocumentNode.SelectSingleNode("//body").InnerText;
				byte[] emailContent = Encoding.UTF8.GetBytes(result);
				file = manager.UploadFile(folder, activity.EmailSubject + ".txt", Convert.ToBase64String(emailContent));
				activity.Sharepoint = new Uri(SoaresPiconSharePoint.SiteUrl + "/" + folder.ServerRelativeUrl).AbsoluteUri;
				activity.UpdateActivityFieldValue("Link do Sharepoint", activity.Sharepoint);
				activity.UpdateActivitySycn(2);
			});
			this.Main.Start();
		}

		// Token: 0x06000253 RID: 595 RVA: 0x00009434 File Offset: 0x00007634
		public void UploadAttachments(Activity activity)
		{
			Application.Current.Dispatcher.Invoke(delegate()
			{
				this.Visibility = Visibility.Visible;
				this.ShowInTaskbar = true;
				this.Show();
				this.terminate = false;
			});
			this.main = new Thread(delegate()
			{
				string clientFolder = (activity.ClientCode != null) ? (activity.ClientCode + " " + activity.Client) : activity.Client;
				string numberFolder = "Consultas/" + clientFolder + "/" + activity.ProcessNumber;
				string emailContent = null;
				bool flag = string.IsNullOrEmpty(activity.EmailReplyContent);
				string attachmentsFolder;
				if (flag)
				{
					attachmentsFolder = "Anexos Recebidos";
					emailContent = activity.EmailContent;
				}
				else
				{
					attachmentsFolder = "Anexos Enviados";
					emailContent = activity.EmailReplyContent;
				}
				string subDir = (activity.Attachments.Count<ZionRobot.Models.ZFlow.Attachment>() == 0) ? numberFolder : (numberFolder + "/" + attachmentsFolder);
				ZionSharePointManager manager = new ZionSharePointManager(SoaresPiconSharePoint.UserName, SoaresPiconSharePoint.Password);
				manager.ConnectToSharePointOnline(SoaresPiconSharePoint.ConsultaUrl);
				List collection = manager.GetCollection("Documentos");
				Microsoft.SharePoint.Client.Folder folder = manager.GetFolder(collection, subDir.Trim(new char[]
				{
					'/'
				}));
				bool flag2 = folder.Name != subDir.Split(new char[]
				{
					'/'
				}).Last<string>() || !folder.Name.StartsWith(subDir.Split(new char[]
				{
					'/'
				}).Last<string>());
				if (flag2)
				{
					folder = manager.BuildFolder(collection, subDir);
				}
				foreach (ZionRobot.Models.ZFlow.Attachment attach in activity.Attachments)
				{
					Microsoft.SharePoint.Client.File file = manager.UploadFile(folder, attach.Name, attach.Content);
					bool flag3 = file == null;
					if (flag3)
					{
						activity.UpdateActivitySycn(3);
						return;
					}
					attach.Link = new Uri(SoaresPiconSharePoint.SiteUrl + file.ServerRelativeUrl);
					attach.UpdateLinkOnZion();
				}
				bool flag4 = folder.Name != numberFolder.Split(new char[]
				{
					'/'
				}).Last<string>() || !folder.Name.StartsWith(numberFolder.Split(new char[]
				{
					'/'
				}).Last<string>());
				if (flag4)
				{
					folder = manager.GetFolder(collection, numberFolder);
				}
				activity.Sharepoint = new Uri(SoaresPiconSharePoint.SiteUrl + "/" + folder.ServerRelativeUrl).AbsoluteUri;
				activity.UpdateActivityFieldValue("Link do Sharepoint", activity.Sharepoint);
				bool flag5 = string.IsNullOrEmpty(emailContent);
				if (flag5)
				{
					activity.UpdateActivitySycn(2);
				}
				else
				{
					HtmlDocument htmlDoc = new HtmlDocument();
					htmlDoc.LoadHtml(emailContent);
					string result = htmlDoc.DocumentNode.InnerHtml;
					string to = activity.EmailTo ?? "consultas@soarespicon.adv.br";
					string from = "consultas@soarespicon.adv.br";
					string subject = activity.EmailSubject;
					string body = result;
					string tempDir = "C:\\Temp\\Email";
					using (SmtpClient client = new SmtpClient())
					{
						MailMessage msg = new MailMessage(from, to, subject, body);
						msg.IsBodyHtml = true;
						msg.BodyEncoding = Encoding.UTF8;
						client.UseDefaultCredentials = true;
						client.DeliveryMethod = SmtpDeliveryMethod.SpecifiedPickupDirectory;
						client.PickupDirectoryLocation = tempDir;
						try
						{
							client.Send(msg);
						}
						catch (Exception ex)
						{
							Environment.Exit(-1);
						}
					}
					FileInfo msgTemp = (from f in new DirectoryInfo(tempDir).GetFiles()
					orderby f.LastWriteTime descending
					select f).First<FileInfo>();
					Microsoft.SharePoint.Client.File file = manager.UploadFile(folder, activity.EmailSubject + ".eml", msgTemp.FullName);
					bool flag6 = file == null;
					if (flag6)
					{
						activity.UpdateActivitySycn(3);
					}
					else
					{
						System.IO.File.Delete(msgTemp.FullName);
						activity.UpdateActivitySycn(2);
					}
				}
			});
			this.Main.Start();
		}

		// Token: 0x06000254 RID: 596 RVA: 0x00009498 File Offset: 0x00007698
		public void CreateSubActivity(Activity activity)
		{
			this.Activity = activity;
			Application.Current.Dispatcher.Invoke(delegate()
			{
				this.Visibility = Visibility.Visible;
				this.ShowInTaskbar = true;
				this.Show();
				this.terminate = false;
			});
			this.main = new Thread(delegate()
			{
				List<ZionRobot.Models.Source.Action> createActivityActions = new List<ZionRobot.Models.Source.Action>();
				createActivityActions = (from be in this.Source.BlockElements
				where be.Name == "CreateActivity"
				select be).FirstOrDefault<BlockElement>().Actions;
				Dictionary<string, string> dictionary = this.DictionaryValues;
				string key = "UrlToCreate";
				string value;
				if ((value = activity.ParentDataJuri) == null)
				{
					value = (activity.CaseURL ?? activity.ProcessURL);
				}
				dictionary.Add(key, value);
				bool flag = !string.IsNullOrEmpty(activity.Content);
				if (flag)
				{
					try
					{
						HtmlDocument doc = new HtmlDocument();
						doc.LoadHtml(activity.Content);
						this.DictionaryValues.Add("Content", doc.DocumentNode.InnerText.Replace("&nbsp;", string.Empty));
					}
					catch (Exception)
					{
						this.DictionaryValues.Add("Content", activity.Content);
					}
				}
				this.DictionaryValues.Add("ZionId", activity.Id.ToString());
				this.DictionaryValues.Add("Responser", activity.Sponsor);
				this.DictionaryValues.Add("ResponserEmail", activity.SponsorEmail);
				this.DictionaryValues.Add("Subject", activity.Subject);
				this.DictionaryValues.Add("Date", Shift.formatDate(activity.Date, "dd/MM/yyyy", "pt-BR"));
				this.DictionaryValues.Add("DateFinal", Shift.formatDate(activity.DateFinal, "dd/MM/yyyy", "pt-BR"));
				this.DictionaryValues.Add("Group", activity.Group);
				this.DictionaryValues.Add("SearchElements.Fields.Tipo", "Publicação");
				bool flag2 = !string.IsNullOrEmpty(activity.Hour);
				if (flag2)
				{
					this.DictionaryValues.Add("Hour", activity.Hour);
				}
				foreach (ZionRobot.Models.Source.Action action in createActivityActions)
				{
					Task<bool> task = this.executeAction(action);
					task.Wait();
					bool execute = task.Result;
				}
				bool flag3 = this.dictionaryValues.ContainsKey("URL da atividade");
				if (flag3)
				{
					activity.DataJuri = this.dictionaryValues["URL da atividade"];
					activity.UpdateActivityUrl();
					activity.UpdateActivitySycn(2);
				}
				else
				{
					activity.UpdateActivitySycn(5);
				}
			});
			this.Main.Start();
		}

		// Token: 0x06000255 RID: 597 RVA: 0x00009508 File Offset: 0x00007708
		public void CreateCase(Activity activity)
		{
			this.Activity = activity;
			Application.Current.Dispatcher.Invoke(delegate()
			{
				this.Visibility = Visibility.Visible;
				this.ShowInTaskbar = true;
				this.Show();
				this.terminate = false;
			});
			this.main = new Thread(delegate()
			{
				List<ZionRobot.Models.Source.Action> UpdateActivityActions = (from be in this.Source.BlockElements
				where be.Name == "CreateCase"
				select be).FirstOrDefault<BlockElement>().Actions;
				HtmlDocument htmlDoc = new HtmlDocument();
				htmlDoc.LoadHtml(activity.EmailContent);
				string result = htmlDoc.DocumentNode.InnerText;
				this.DictionaryValues.Add("CaseURL", activity.CaseURL);
				this.DictionaryValues.Add("Responser", activity.Sponsor);
				this.DictionaryValues.Add("ResponserEmail", activity.SponsorEmail);
				this.DictionaryValues.Add("Area", this.translateArea(activity.Subject));
				this.DictionaryValues.Add("CreatedAt", Shift.formatDate(activity.CreatedAt, "dd/MM/yyyy", "pt-BR"));
				this.DictionaryValues.Add("EmailSubject", activity.EmailSubject);
				this.DictionaryValues.Add("EmailContent", result);
				this.DictionaryValues.Add("Priority", activity.Priority);
				this.DictionaryValues.Add("Sharepoint", activity.Sharepoint);
				this.DictionaryValues.Add("Client", activity.Client);
				this.DictionaryValues.Add("FolderNumber", activity.ProcessNumber);
				foreach (ZionRobot.Models.Source.Action action in UpdateActivityActions)
				{
					Task<bool> task = this.executeAction(action);
					task.Wait();
					bool execute = task.Result;
				}
				bool flag = this.dictionaryValues.ContainsKey("CaseUrl");
				if (flag)
				{
					activity.CaseURL = this.dictionaryValues["CaseUrl"];
					activity.UpdateActivityFieldValue("Link do Caso", activity.CaseURL);
					activity.UpdateActivitySycn(2);
				}
				else
				{
					activity.UpdateActivitySycn(5);
				}
			});
			this.Main.Start();
		}

		// Token: 0x06000256 RID: 598 RVA: 0x00009578 File Offset: 0x00007778
		public void CloseCase(Activity activity)
		{
			this.Activity = activity;
			Application.Current.Dispatcher.Invoke(delegate()
			{
				this.Visibility = Visibility.Visible;
				this.ShowInTaskbar = true;
				this.Show();
				this.terminate = false;
			});
			this.main = new Thread(delegate()
			{
				List<ZionRobot.Models.Source.Action> UpdateActivityActions = (from be in this.Source.BlockElements
				where be.Name == "CloseCase"
				select be).FirstOrDefault<BlockElement>().Actions;
				HtmlDocument htmlDoc = new HtmlDocument();
				htmlDoc.LoadHtml(activity.EmailReplyContent);
				string result = htmlDoc.DocumentNode.InnerText;
				this.DictionaryValues.Add("CaseUrl", activity.CaseURL);
				this.DictionaryValues.Add("Responser", activity.Sponsor);
				this.DictionaryValues.Add("SyncCreateAt", Shift.formatDate(activity.SyncCreateAt, "dd/MM/yyyy", "pt-BR"));
				this.DictionaryValues.Add("EmailReplyContent", result);
				foreach (ZionRobot.Models.Source.Action action in UpdateActivityActions)
				{
					Task<bool> task = this.executeAction(action);
					task.Wait();
					bool execute = task.Result;
				}
				activity.UpdateActivitySycn(2);
			});
			this.Main.Start();
		}

		// Token: 0x06000257 RID: 599 RVA: 0x000095E8 File Offset: 0x000077E8
		private string translateArea(string area)
		{
			uint num = <PrivateImplementationDetails>.ComputeStringHash(area);
			if (num <= 1241302063U)
			{
				if (num <= 794282553U)
				{
					if (num != 386975329U)
					{
						if (num != 776646911U)
						{
							if (num != 794282553U)
							{
								goto IL_196;
							}
							if (!(area == "Trabalhista - Justa Causa"))
							{
								goto IL_196;
							}
						}
						else
						{
							if (!(area == "Contratos - Plano de saúde (Convênios)"))
							{
								goto IL_196;
							}
							goto IL_18E;
						}
					}
					else
					{
						if (!(area == "Contratos - Locação"))
						{
							goto IL_196;
						}
						goto IL_18E;
					}
				}
				else if (num != 914995025U)
				{
					if (num != 1224632208U)
					{
						if (num != 1241302063U)
						{
							goto IL_196;
						}
						if (!(area == "Contratos - Outros"))
						{
							goto IL_196;
						}
						goto IL_18E;
					}
					else
					{
						if (!(area == "Contratos - Compra e Venda"))
						{
							goto IL_196;
						}
						goto IL_18E;
					}
				}
				else if (!(area == "Trabalhista - Outros"))
				{
					goto IL_196;
				}
			}
			else if (num <= 2200322199U)
			{
				if (num != 1249023226U)
				{
					if (num != 2168012727U)
					{
						if (num != 2200322199U)
						{
							goto IL_196;
						}
						if (!(area == "Trabalhista - Afastamento INSS"))
						{
							goto IL_196;
						}
					}
					else if (!(area == "Trabalhista - Estágio"))
					{
						goto IL_196;
					}
				}
				else
				{
					if (!(area == "Contratos - Internacional"))
					{
						goto IL_196;
					}
					goto IL_18E;
				}
			}
			else if (num != 2676606078U)
			{
				if (num != 3041903933U)
				{
					if (num != 4101459249U)
					{
						goto IL_196;
					}
					if (!(area == "Trabalhista - Outras Sanções"))
					{
						goto IL_196;
					}
				}
				else if (!(area == "Trabalhista - Contrato de Trabalho"))
				{
					goto IL_196;
				}
			}
			else
			{
				if (!(area == "Contratos - Prestação de Serviços"))
				{
					goto IL_196;
				}
				goto IL_18E;
			}
			return "Trabalhista";
			IL_18E:
			return "Contratos";
			IL_196:
			return area;
		}

		// Token: 0x06000258 RID: 600 RVA: 0x00009790 File Offset: 0x00007990
		public void UpdateActivity(Activity activity)
		{
			this.Activity = activity;
			Application.Current.Dispatcher.Invoke(delegate()
			{
				this.Visibility = Visibility.Visible;
				this.ShowInTaskbar = true;
				this.Show();
				this.terminate = false;
			});
			Func<BlockElement, bool> <>9__2;
			this.main = new Thread(delegate()
			{
				IEnumerable<BlockElement> blockElements = this.Source.BlockElements;
				Func<BlockElement, bool> predicate;
				if ((predicate = <>9__2) == null)
				{
					predicate = (<>9__2 = ((BlockElement be) => be.Name == ((activity.CaseURL != null) ? "UpdateActivityConsulta" : "UpdateActivity")));
				}
				List<ZionRobot.Models.Source.Action> UpdateActivityActions = blockElements.Where(predicate).FirstOrDefault<BlockElement>().Actions;
				this.DictionaryValues.Add("ZionId", activity.Id.ToString());
				this.DictionaryValues.Add("ActivityUrl", activity.DataJuri);
				this.DictionaryValues.Add("Responser", activity.Sponsor);
				this.DictionaryValues.Add("ResponserEmail", activity.SponsorEmail);
				this.DictionaryValues.Add("Subject", activity.Subject);
				this.DictionaryValues.Add("Date", Shift.formatDate(activity.Date, "dd/MM/yyyy", "pt-BR"));
				this.DictionaryValues.Add("DateFinal", Shift.formatDate(activity.DateFinal, "dd/MM/yyyy", "pt-BR"));
				this.DictionaryValues.Add("Group", activity.Group);
				this.DictionaryValues.Add("SearchElements.Fields.Tipo", "Publicação");
				this.DictionaryValues.Add("ActivityStatus", this.translateActivityStatus(activity.Status));
				this.DictionaryValues.Add("Client", activity.Client);
				this.DictionaryValues.Add("FolderNumber", activity.ProcessNumber);
				bool flag = !string.IsNullOrEmpty(activity.Content);
				if (flag)
				{
					try
					{
						HtmlDocument doc = new HtmlDocument();
						doc.LoadHtml(activity.Content);
						this.DictionaryValues.Add("Content", doc.DocumentNode.InnerText.Replace("&nbsp;", string.Empty));
					}
					catch (Exception)
					{
						this.DictionaryValues.Add("Content", activity.Content);
					}
				}
				bool flag2 = activity.Comment != null;
				if (flag2)
				{
					this.DictionaryValues.Add("CommentResponser", activity.CommentCreateBy);
					this.DictionaryValues.Add("CommentSubject", activity.Subject);
					this.DictionaryValues.Add("CommentValue", activity.Comment);
				}
				bool flag3 = !string.IsNullOrEmpty(activity.Parecer);
				if (flag3)
				{
					HtmlDocument htmlDoc = new HtmlDocument();
					htmlDoc.LoadHtml(activity.Parecer);
					string result = htmlDoc.DocumentNode.InnerText;
					this.DictionaryValues.Add("ActivityParecer", result);
				}
				foreach (ZionRobot.Models.Source.Action action in UpdateActivityActions)
				{
					Task<bool> task = this.executeAction(action);
					task.Wait();
					bool execute = task.Result;
				}
				activity.UpdateActivitySycn(2);
			});
			this.Main.Start();
		}

		// Token: 0x06000259 RID: 601 RVA: 0x00009800 File Offset: 0x00007A00
		private string translateActivityStatus(string status)
		{
			string text = status;
			string text2 = text;
			if ((text2 == null || text2.Length != 0) && !(text2 == "0"))
			{
				if (!(text2 == "2") && !(text2 == "3"))
				{
					if (!(text2 == "4"))
					{
						status = "Não iniciado";
					}
					else
					{
						status = "Aguardando";
					}
				}
				else
				{
					status = "Concluído";
				}
			}
			else
			{
				status = "Cancelado";
			}
			return status;
		}

		// Token: 0x0600025A RID: 602 RVA: 0x0000987C File Offset: 0x00007A7C
		public void SyncActivityCanceling(Activity activity)
		{
			Application.Current.Dispatcher.Invoke(delegate()
			{
				this.Visibility = Visibility.Visible;
				this.ShowInTaskbar = true;
				this.Show();
				this.terminate = false;
			});
			this.main = new Thread(delegate()
			{
				bool execute = true;
				this.DictionaryValues.Add("ActivityUrl", activity.DataJuri);
				List<ZionRobot.Models.Source.Action> authenticateActions = (from be in this.Source.BlockElements
				where be.Name == "Authenticate"
				select be).FirstOrDefault<BlockElement>().Actions;
				foreach (ZionRobot.Models.Source.Action action in authenticateActions)
				{
					Task<bool> task = this.executeAction(action);
					task.Wait();
					execute = task.Result;
				}
				List<ZionRobot.Models.Source.Action> createCommentActions = (from be in this.Source.BlockElements
				where be.Name == "CreateComment"
				select be).FirstOrDefault<BlockElement>().Actions;
				bool flag = createCommentActions != null;
				if (flag)
				{
					(from c in activity.Comments
					orderby c.CreatedAt
					select c).ToList<Comment>().ForEach(delegate(Comment comment)
					{
						this.DictionaryValues.Add("CommentResponser", comment.CreatedByName);
						this.DictionaryValues.Add("CommentSubject", comment.Subject);
						this.DictionaryValues.Add("CommentValue", comment.Value);
						foreach (ZionRobot.Models.Source.Action action3 in createCommentActions)
						{
							Task<bool> task3 = this.executeAction(action3);
							task3.Wait();
							execute = task3.Result;
						}
						this.DictionaryValues.Remove("CommentResponser");
						this.DictionaryValues.Remove("CommentSubject");
						this.DictionaryValues.Remove("CommentValue");
					});
				}
				List<ZionRobot.Models.Source.Action> cancelingActivityActions = (from be in this.Source.BlockElements
				where be.Name == "CancelingActivity"
				select be).FirstOrDefault<BlockElement>().Actions;
				bool flag2 = cancelingActivityActions != null;
				if (flag2)
				{
					foreach (ZionRobot.Models.Source.Action action2 in cancelingActivityActions)
					{
						Task<bool> task2 = this.executeAction(action2);
						task2.Wait();
						execute = task2.Result;
					}
				}
				activity.CanceledActivity();
			});
			this.Main.Start();
		}

		// Token: 0x0600025B RID: 603 RVA: 0x000098E0 File Offset: 0x00007AE0
		[DebuggerStepThrough]
		private Task<bool> executeAction(ZionRobot.Models.Source.Action action)
		{
			Browser.<executeAction>d__48 <executeAction>d__ = new Browser.<executeAction>d__48();
			<executeAction>d__.<>t__builder = AsyncTaskMethodBuilder<bool>.Create();
			<executeAction>d__.<>4__this = this;
			<executeAction>d__.action = action;
			<executeAction>d__.<>1__state = -1;
			<executeAction>d__.<>t__builder.Start<Browser.<executeAction>d__48>(ref <executeAction>d__);
			return <executeAction>d__.<>t__builder.Task;
		}

		// Token: 0x0600025C RID: 604 RVA: 0x0000992C File Offset: 0x00007B2C
		private List<IHTMLElement> getHTMLElements(string where, IHTMLElementCollection elementCollection = null)
		{
			HTMLDocument htmlDoc = this.GetHTMLDocument();
			bool flag = htmlDoc.all == null && elementCollection == null;
			List<IHTMLElement> result;
			if (flag)
			{
				result = new List<IHTMLElement>();
			}
			else
			{
				List<IHTMLElementCollection> list = new List<IHTMLElementCollection>
				{
					(elementCollection != null) ? elementCollection : htmlDoc.all
				};
				result = CQuery.Find(where, list);
			}
			return result;
		}

		// Token: 0x0600025D RID: 605 RVA: 0x00009980 File Offset: 0x00007B80
		private bool checkDictionaryKey(ZionRobot.Models.Source.Action action)
		{
			bool flag = this.dictionaryValues.ContainsKey(action.Value) && action.ResultTrue.Count > 0;
			bool result;
			if (flag)
			{
				action.ResultTrue.ForEach(delegate(ZionRobot.Models.Source.Action a)
				{
					this.executeAction(a).Wait();
				});
				result = true;
			}
			else
			{
				bool flag2 = action.ResultFalse.Count > 0;
				if (flag2)
				{
					action.ResultFalse.ForEach(delegate(ZionRobot.Models.Source.Action a)
					{
						this.executeAction(a).Wait();
					});
					result = true;
				}
				else
				{
					result = false;
				}
			}
			return result;
		}

		// Token: 0x0600025E RID: 606 RVA: 0x00009A08 File Offset: 0x00007C08
		private bool appendFromApi(ZionRobot.Models.Source.Action action)
		{
			bool result2;
			try
			{
				string value = action.ReplaceWithDictionary(action.Where, this.DictionaryValues);
				string result = new Client(WSProperties.UrlApi)._request("GET", value, WSProperties.Token, null, string.Empty, null);
				JavaScriptSerializer jsonSerialiser = new JavaScriptSerializer();
				Dictionary<string, string> json = jsonSerialiser.Deserialize<Dictionary<string, string>>(result);
				json.ToList<KeyValuePair<string, string>>().ForEach(delegate(KeyValuePair<string, string> j)
				{
					this.dictionaryValues.Add(j.Key, j.Value);
				});
				result2 = true;
			}
			catch (Exception ex)
			{
				result2 = false;
			}
			return result2;
		}

		// Token: 0x0600025F RID: 607 RVA: 0x00009A94 File Offset: 0x00007C94
		private bool changeAttributeValue(ZionRobot.Models.Source.Action action)
		{
			IHTMLElement element = this.getHTMLElements(action.Where, null).FirstOrDefault<IHTMLElement>();
			bool flag = element == null;
			bool result;
			if (flag)
			{
				result = false;
			}
			else
			{
				string[] parts = action.Value.Split("=".ToCharArray(), 2);
				element.setAttribute(parts[0], (parts.Length == 1) ? string.Empty : parts[1], 1);
				result = true;
			}
			return result;
		}

		// Token: 0x06000260 RID: 608 RVA: 0x00009AFC File Offset: 0x00007CFC
		private bool readJson(ZionRobot.Models.Source.Action action)
		{
			bool result2;
			try
			{
				using (WebClient wc = new WebClient
				{
					Encoding = Encoding.UTF8
				})
				{
					string result = this.ReplaceActionsValue(action);
					string json = wc.DownloadString(result);
					bool flag = string.IsNullOrEmpty(json);
					if (flag)
					{
						return false;
					}
					IntimacoesCollection IC = JsonSerializer.Deserialize<IntimacoesCollection>(json, new JsonSerializerOptions
					{
						PropertyNameCaseInsensitive = true
					});
					IC.Intimacoes.ForEach(delegate(Intimacao intimacao)
					{
						List<Element> listElements = new List<Element>();
						this.source.SearchElements.ForEach(delegate(Element element)
						{
							element.Value = ((element.Where.ToUpper() == "ALL") ? intimacao.GetParamAASP() : intimacao.GetParamValue(element.Where));
							listElements.Add(new Element(element.Name, element.Where, element.Value, element.GoTo, element.IsHtml, element.Attribute));
						});
						this.searchElements.Add(listElements);
					});
				}
				result2 = true;
			}
			catch (Exception ex)
			{
				result2 = false;
			}
			return result2;
		}

		// Token: 0x06000261 RID: 609 RVA: 0x00009BA4 File Offset: 0x00007DA4
		private bool invokeOnClick(ZionRobot.Models.Source.Action action)
		{
			IHTMLElement element = this.getHTMLElements(action.Where, null).FirstOrDefault<IHTMLElement>();
			return element != null;
		}

		// Token: 0x06000262 RID: 610 RVA: 0x00009BD8 File Offset: 0x00007DD8
		private bool executeBLock(ZionRobot.Models.Source.Action action)
		{
			BlockElement block = (from b in this.source.BlockElements
			where b.Name == action.Value
			select b).FirstOrDefault<BlockElement>();
			bool flag = block != null;
			bool result;
			if (flag)
			{
				foreach (ZionRobot.Models.Source.Action a in block.Actions)
				{
					Task<bool> task = this.executeAction(a);
					task.Wait();
				}
				result = true;
			}
			else
			{
				result = false;
			}
			return result;
		}

		// Token: 0x06000263 RID: 611 RVA: 0x00009C80 File Offset: 0x00007E80
		[DebuggerStepThrough]
		private Task<bool> navigate(ZionRobot.Models.Source.Action action)
		{
			Browser.<navigate>d__56 <navigate>d__ = new Browser.<navigate>d__56();
			<navigate>d__.<>t__builder = AsyncTaskMethodBuilder<bool>.Create();
			<navigate>d__.<>4__this = this;
			<navigate>d__.action = action;
			<navigate>d__.<>1__state = -1;
			<navigate>d__.<>t__builder.Start<Browser.<navigate>d__56>(ref <navigate>d__);
			return <navigate>d__.<>t__builder.Task;
		}

		// Token: 0x06000264 RID: 612 RVA: 0x00009CCC File Offset: 0x00007ECC
		private bool readResultsFromPage(ZionRobot.Models.Source.Action action)
		{
			List<IHTMLElement> hElements = this.getHTMLElements(action.Where, null).ToList<IHTMLElement>();
			bool flag = hElements.Count == 0;
			bool result;
			if (flag)
			{
				result = false;
			}
			else
			{
				hElements.ForEach(delegate(IHTMLElement hElement)
				{
					List<Element> listElements = new List<Element>();
					this.source.SearchElements.ForEach(delegate(Element element)
					{
						bool flag2 = string.IsNullOrEmpty(element.Attribute);
						if (flag2)
						{
							Browser <>4__this = this;
							string where = element.Where;
							if (Browser.<>o__57.<>p__0 == null)
							{
								Browser.<>o__57.<>p__0 = CallSite<Func<CallSite, object, IHTMLElementCollection>>.Create(Microsoft.CSharp.RuntimeBinder.Binder.Convert(CSharpBinderFlags.ConvertExplicit, typeof(IHTMLElementCollection), typeof(Browser)));
							}
							IHTMLElement ihtmlelement = <>4__this.getHTMLElements(where, Browser.<>o__57.<>p__0.Target(Browser.<>o__57.<>p__0, hElement.all)).FirstOrDefault<IHTMLElement>();
							element.Value = (((ihtmlelement != null) ? ihtmlelement.innerText : null) ?? string.Empty);
						}
						else
						{
							if (Browser.<>o__57.<>p__1 == null)
							{
								Browser.<>o__57.<>p__1 = CallSite<Func<CallSite, object, string>>.Create(Microsoft.CSharp.RuntimeBinder.Binder.Convert(CSharpBinderFlags.None, typeof(string), typeof(Browser)));
							}
							element.Value = Browser.<>o__57.<>p__1.Target(Browser.<>o__57.<>p__1, hElement.getAttribute(element.Attribute, 0));
						}
						element.Value = Regex.Replace(element.Value, "  Exibir comentários  Inserir comentários ", string.Empty);
						bool isHtml = element.IsHtml;
						if (isHtml)
						{
							HtmlDocument doc = new HtmlDocument();
							doc.LoadHtml(element.Value);
							element.Value = doc.DocumentNode.InnerText;
						}
						listElements.Add(new Element(element.Name, element.Where, element.Value, element.GoTo, element.IsHtml, element.Attribute));
					});
					this.searchElements.Add(listElements);
				});
				result = true;
			}
			return result;
		}

		// Token: 0x06000265 RID: 613 RVA: 0x00009D18 File Offset: 0x00007F18
		private bool invoke(ZionRobot.Models.Source.Action action)
		{
			bool flag = action.Where != null;
			if (flag)
			{
				IHTMLElement element = this.getHTMLElements(action.Where.Replace("@", ""), null).FirstOrDefault<IHTMLElement>();
				bool flag2 = element != null;
				if (flag2)
				{
					if (Browser.<>o__58.<>p__0 == null)
					{
						Browser.<>o__58.<>p__0 = CallSite<Func<CallSite, object, string>>.Create(Microsoft.CSharp.RuntimeBinder.Binder.Convert(CSharpBinderFlags.ConvertExplicit, typeof(string), typeof(Browser)));
					}
					string[] parts = Browser.<>o__58.<>p__0.Target(Browser.<>o__58.<>p__0, element.getAttribute("href", 0)).Split(new char[]
					{
						'('
					});
					string scriptName = parts[0].Replace("javascript:", string.Empty);
					string[] args = parts[1].Trim(new char[]
					{
						')'
					}).Replace("'", string.Empty).Split(new char[]
					{
						','
					});
					IHTMLElement elementTemp = string.IsNullOrEmpty(action.Check) ? null : this.getHTMLElements(action.Check, null).First<IHTMLElement>();
					this.browser.Dispatcher.Invoke(delegate()
					{
						WebBrowser webBrowser = this.browser;
						string scriptName = scriptName;
						object[] args = args;
						webBrowser.InvokeScript(scriptName, args);
					});
					bool flag3 = elementTemp != null;
					if (flag3)
					{
						while (CQuery.CompareInnerHtmlByElements(elementTemp, this.getHTMLElements(action.Check, null).First<IHTMLElement>()))
						{
							Thread.Sleep(200);
						}
						return true;
					}
					return true;
				}
			}
			bool flag4 = action.Value != null;
			if (flag4)
			{
				bool flag5 = Regex.IsMatch(action.Value, "javascript");
				if (flag5)
				{
					string[] parts2 = action.Value.Split(new char[]
					{
						'('
					});
					string scriptName = parts2[0].Trim().Replace("javascript:", string.Empty).Trim();
					string[] args = parts2[1].Trim(new char[]
					{
						')'
					}).Replace("'", string.Empty).Split(new char[]
					{
						','
					});
					IHTMLElement elementTemp2 = string.IsNullOrEmpty(action.Check) ? null : this.getHTMLElements(action.Check, null).First<IHTMLElement>();
					this.browser.Dispatcher.Invoke(delegate()
					{
						WebBrowser webBrowser = this.browser;
						string scriptName = scriptName;
						object[] args = args;
						webBrowser.InvokeScript(scriptName, args);
					});
					bool flag6 = elementTemp2 != null;
					if (flag6)
					{
						while (CQuery.CompareInnerHtmlByElements(elementTemp2, this.getHTMLElements(action.Check, null).First<IHTMLElement>()))
						{
							Thread.Sleep(200);
						}
						return true;
					}
					return true;
				}
			}
			return false;
		}

		// Token: 0x06000266 RID: 614 RVA: 0x00009FF0 File Offset: 0x000081F0
		private bool fillInput(ZionRobot.Models.Source.Action action)
		{
			List<IHTMLElement> elements = this.getHTMLElements(action.Where, null);
			bool flag = elements.Count > 0;
			bool result;
			if (flag)
			{
				elements.ForEach(delegate(IHTMLElement element)
				{
					element.setAttribute("value", this.ReplaceActionsValue(action), 1);
				});
				result = true;
			}
			else
			{
				result = false;
			}
			return result;
		}

		// Token: 0x06000267 RID: 615 RVA: 0x0000A050 File Offset: 0x00008250
		private bool checkInput(ZionRobot.Models.Source.Action action)
		{
			IHTMLElement element = this.getHTMLElements(action.Where, null).FirstOrDefault<IHTMLElement>();
			bool flag = element == null;
			bool result;
			if (flag)
			{
				result = false;
			}
			else
			{
				(element as HTMLInputElement).@checked = bool.Parse(action.Value);
				result = true;
			}
			return result;
		}

		// Token: 0x06000268 RID: 616 RVA: 0x0000A09C File Offset: 0x0000829C
		private bool selectOption(ZionRobot.Models.Source.Action action)
		{
			string value = action.ReplaceWithDictionary(action.Where, this.DictionaryValues);
			IHTMLElement element = this.getHTMLElements(value, null).FirstOrDefault<IHTMLElement>();
			bool flag = element != null;
			bool result;
			if (flag)
			{
				element.setAttribute("selected", "Selected", 1);
				result = true;
			}
			else
			{
				result = false;
			}
			return result;
		}

		// Token: 0x06000269 RID: 617 RVA: 0x0000A0F0 File Offset: 0x000082F0
		[DebuggerStepThrough]
		private Task<bool> clickButton(ZionRobot.Models.Source.Action action)
		{
			Browser.<clickButton>d__62 <clickButton>d__ = new Browser.<clickButton>d__62();
			<clickButton>d__.<>t__builder = AsyncTaskMethodBuilder<bool>.Create();
			<clickButton>d__.<>4__this = this;
			<clickButton>d__.action = action;
			<clickButton>d__.<>1__state = -1;
			<clickButton>d__.<>t__builder.Start<Browser.<clickButton>d__62>(ref <clickButton>d__);
			return <clickButton>d__.<>t__builder.Task;
		}

		// Token: 0x0600026A RID: 618 RVA: 0x0000A13C File Offset: 0x0000833C
		private bool executeIf(ZionRobot.Models.Source.Action action)
		{
			string @operator = (from Match match in Regex.Matches(action.Value, "([!=_<>]{1,2}=?)|\\d+")
			select match.Value).First<string>();
			string[] parts = action.Value.Split(new string[]
			{
				@operator
			}, StringSplitOptions.RemoveEmptyEntries);
			string value = string.Empty;
			bool flag = parts.Count<string>() > 0;
			if (flag)
			{
				value = action.ReplaceWithDictionary(parts[0], this.DictionaryValues);
				value = value.Replace(@operator, string.Empty);
			}
			IHTMLElement element = this.getHTMLElements(action.Where, null).FirstOrDefault<IHTMLElement>();
			bool flag2 = element != null;
			if (flag2)
			{
				string fa = element.innerText;
				bool x = fa == value;
				int y = parts.Count<string>();
				bool flag3 = @operator == "=_=" || (@operator == "==" && element.innerText == value) || (@operator == "==" && parts.Count<string>() > 1 && action.ReplaceWithDictionary(parts[0], this.DictionaryValues) == action.ReplaceWithDictionary(parts[1], this.DictionaryValues)) || (@operator == "===" && Regex.IsMatch(element.innerText, value)) || (@operator == "!=" && element.innerText != value) || (@operator == "!==" && !Regex.IsMatch(element.innerText, value));
				if (flag3)
				{
					action.ResultTrue.ForEach(delegate(ZionRobot.Models.Source.Action a)
					{
						this.executeAction(a).Wait();
					});
					return true;
				}
				bool flag4 = action.ResultFalse.Count > 0;
				if (flag4)
				{
					Console.WriteLine("ELLSEEEEEEE");
					action.ResultFalse.ForEach(delegate(ZionRobot.Models.Source.Action a)
					{
						this.executeAction(a).Wait();
					});
					return true;
				}
			}
			return false;
		}

		// Token: 0x0600026B RID: 619 RVA: 0x0000A33C File Offset: 0x0000853C
		[DebuggerStepThrough]
		private Task<bool> loopWithOperator(ZionRobot.Models.Source.Action action)
		{
			Browser.<loopWithOperator>d__64 <loopWithOperator>d__ = new Browser.<loopWithOperator>d__64();
			<loopWithOperator>d__.<>t__builder = AsyncTaskMethodBuilder<bool>.Create();
			<loopWithOperator>d__.<>4__this = this;
			<loopWithOperator>d__.action = action;
			<loopWithOperator>d__.<>1__state = -1;
			<loopWithOperator>d__.<>t__builder.Start<Browser.<loopWithOperator>d__64>(ref <loopWithOperator>d__);
			return <loopWithOperator>d__.<>t__builder.Task;
		}

		// Token: 0x0600026C RID: 620 RVA: 0x0000A388 File Offset: 0x00008588
		[DebuggerStepThrough]
		private Task<bool> loopWithBoolean(ZionRobot.Models.Source.Action action)
		{
			Browser.<loopWithBoolean>d__65 <loopWithBoolean>d__ = new Browser.<loopWithBoolean>d__65();
			<loopWithBoolean>d__.<>t__builder = AsyncTaskMethodBuilder<bool>.Create();
			<loopWithBoolean>d__.<>4__this = this;
			<loopWithBoolean>d__.action = action;
			<loopWithBoolean>d__.<>1__state = -1;
			<loopWithBoolean>d__.<>t__builder.Start<Browser.<loopWithBoolean>d__65>(ref <loopWithBoolean>d__);
			return <loopWithBoolean>d__.<>t__builder.Task;
		}

		// Token: 0x0600026D RID: 621 RVA: 0x0000A3D4 File Offset: 0x000085D4
		private bool checkDomain(ZionRobot.Models.Source.Action action)
		{
			HTMLDocument doc = null;
			string domain = null;
			this.browser.Dispatcher.Invoke(delegate()
			{
				doc = (HTMLDocument)this.browser.Document;
				bool flag2 = doc != null;
				if (flag2)
				{
					domain = doc.domain;
				}
			});
			bool flag = domain == null || domain == string.Empty || domain != this.source.Domain;
			bool result;
			if (flag)
			{
				action.ResultTrue.ForEach(delegate(ZionRobot.Models.Source.Action a)
				{
					this.executeAction(a).Wait();
				});
				result = true;
			}
			else
			{
				result = true;
			}
			return result;
		}

		// Token: 0x0600026E RID: 622 RVA: 0x0000A474 File Offset: 0x00008674
		[DebuggerStepThrough]
		private Task<bool> goBack(ZionRobot.Models.Source.Action action)
		{
			Browser.<goBack>d__67 <goBack>d__ = new Browser.<goBack>d__67();
			<goBack>d__.<>t__builder = AsyncTaskMethodBuilder<bool>.Create();
			<goBack>d__.<>4__this = this;
			<goBack>d__.action = action;
			<goBack>d__.<>1__state = -1;
			<goBack>d__.<>t__builder.Start<Browser.<goBack>d__67>(ref <goBack>d__);
			return <goBack>d__.<>t__builder.Task;
		}

		// Token: 0x0600026F RID: 623 RVA: 0x0000A4C0 File Offset: 0x000086C0
		private bool appendData(ZionRobot.Models.Source.Action action)
		{
			string actionWhere = action.ReplaceWithDictionary(action.Where, this.DictionaryValues);
			bool flag = actionWhere == "currentUrl";
			bool result;
			if (flag)
			{
				this.DictionaryValues.Add(action.Value, this.getUrl());
				result = true;
			}
			else
			{
				IHTMLElement ihtmlelement;
				if (action.Regex == null)
				{
					ihtmlelement = this.getHTMLElements(actionWhere, null).FirstOrDefault<IHTMLElement>();
				}
				else
				{
					ihtmlelement = (from e in this.getHTMLElements(actionWhere, null)
					where e.innerText != null && Regex.IsMatch(e.innerText, action.Regex)
					select e).FirstOrDefault<IHTMLElement>();
				}
				IHTMLElement element = ihtmlelement;
				bool flag2 = element != null;
				if (flag2)
				{
					bool flag3 = this.DictionaryValues.FirstOrDefault((KeyValuePair<string, string> x) => x.Key == action.Value).Key != null;
					if (flag3)
					{
						this.DictionaryValues.Remove(action.Value);
					}
					bool flag4 = action.Attribute != null;
					if (flag4)
					{
						if (Browser.<>o__68.<>p__0 == null)
						{
							Browser.<>o__68.<>p__0 = CallSite<Func<CallSite, object, string>>.Create(Microsoft.CSharp.RuntimeBinder.Binder.Convert(CSharpBinderFlags.ConvertExplicit, typeof(string), typeof(Browser)));
						}
						string a = Browser.<>o__68.<>p__0.Target(Browser.<>o__68.<>p__0, element.getAttribute(action.Attribute, 0));
						this.DictionaryValues.Add(action.Value, a);
					}
					else
					{
						this.DictionaryValues.Add(action.Value, element.innerText);
					}
					result = true;
				}
				else
				{
					result = false;
				}
			}
			return result;
		}

		// Token: 0x06000270 RID: 624 RVA: 0x0000A68C File Offset: 0x0000888C
		private bool saveIntegrationLog(ZionRobot.Models.Source.Action action)
		{
			string value = this.ReplaceActionsValue(action);
			System.IO.File.AppendAllText(Basic.LogsFolder + "IntegrationLog.csv", string.Format("{0}{1}\n", DateTime.Now, value));
			return true;
		}

		// Token: 0x06000271 RID: 625 RVA: 0x0000A6D4 File Offset: 0x000088D4
		private string getUrl()
		{
			string url = string.Empty;
			this.browser.Dispatcher.Invoke(delegate()
			{
				url = this.browser.Source.AbsoluteUri;
			});
			return url;
		}

		// Token: 0x06000272 RID: 626 RVA: 0x0000A724 File Offset: 0x00008924
		private HTMLDocument GetHTMLDocument()
		{
			HTMLDocument doc = null;
			this.browser.Dispatcher.Invoke(DispatcherPriority.Normal, new System.Action(delegate()
			{
				doc = (HTMLDocument)this.browser.Document;
			}));
			return doc;
		}

		// Token: 0x06000273 RID: 627 RVA: 0x0000A770 File Offset: 0x00008970
		private bool hasLog(string text)
		{
			foreach (string r in Logs.SearchLog.SearchResults)
			{
				foreach (string v in r.Split(new string[]
				{
					"||"
				}, StringSplitOptions.None).ToList<string>())
				{
					string ab = text.Replace(Environment.NewLine, "");
					bool flag = v == ab;
					if (flag)
					{
						return true;
					}
					bool flag2 = v == text;
					if (flag2)
					{
						return true;
					}
				}
			}
			return false;
		}

		// Token: 0x06000274 RID: 628 RVA: 0x0000A860 File Offset: 0x00008A60
		private string ReplaceActionsValue(ZionRobot.Models.Source.Action action)
		{
			string value = string.Empty;
			List<string> parts = (from Match m in Regex.Matches(action.Value, "\\{[^\\}]*\\}|([:=\\[\\(\\{]{0}[a-zA-Z0-9_%@\\-\\.\\/:?=&;]{1,})")
			select m.Value).ToList<string>();
			parts.ForEach(delegate(string part)
			{
				string temp = part.Trim(new char[]
				{
					'{'
				}).Trim(new char[]
				{
					'}'
				});
				string add = string.Empty;
				bool flag2 = Regex.IsMatch(temp, "\\$_Now");
				if (flag2)
				{
					DateTime dateNow = DateTime.Now;
					int day = 0;
					string[] p = temp.Split(new char[]
					{
						'?'
					});
					bool flag3 = p.Count<string>() == 1;
					if (flag3)
					{
						bool flag4 = Regex.IsMatch(p[0], "\\.");
						if (flag4)
						{
							day = int.Parse(temp.Split(new char[]
							{
								'.'
							}).Last<string>());
						}
					}
					else
					{
						string @operator = (from Match match in Regex.Matches(p[0], "([!=<>]{1,2}[<>=]?)")
						select match.Value).First<string>();
						string[] s = p[0].Split(new string[]
						{
							@operator
						}, StringSplitOptions.RemoveEmptyEntries);
						int hours = int.Parse(s[1]);
						string[] days = p[1].Split(new char[]
						{
							':'
						});
						bool flag5 = (@operator == "==" && dateNow.Hour == hours) || (@operator == "!=" && dateNow.Hour != hours) || (@operator == "<=" && dateNow.Hour <= hours) || (@operator == ">=" && dateNow.Hour >= hours) || (@operator == ">" && dateNow.Hour > hours) || (@operator == "<" && dateNow.Hour < hours);
						if (flag5)
						{
							day = int.Parse(days[0]);
						}
						else
						{
							day = int.Parse(days[1]);
						}
					}
					add = ((day == 0) ? dateNow.ToString("dd/MM/yyyy") : this.getBusinessDay(DateTime.Now, day).ToString("dd/MM/yyyy"));
				}
				bool flag6 = this.DictionaryValues.ContainsKey(temp);
				if (flag6)
				{
					bool flag7 = string.IsNullOrEmpty(this.DictionaryValues[temp]);
					if (flag7)
					{
						part = string.Empty;
					}
					else
					{
						bool flag8 = action.Where == "input[id=data_da_disponibilizStr]" && this.DictionaryValues["SearchElements.Fields.Tipo"] == "Publicação";
						if (flag8)
						{
							add += this.getBusinessDay(DateTime.Parse(this.DictionaryValues[temp]), -1).ToString("dd/MM/yyyy");
						}
						else
						{
							bool flag9 = action.Where == "input[id=data_de_publicacaoStr]" && (this.DictionaryValues["SearchElements.Fields.Tipo"] == "Disponibilização" || this.DictionaryValues["SearchElements.Fields.Tipo"] == "Divulgação");
							if (flag9)
							{
								add += this.getBusinessDay(DateTime.Parse(this.DictionaryValues[temp]), 1).ToString("dd/MM/yyyy");
							}
							else
							{
								add += this.DictionaryValues[temp];
							}
						}
					}
				}
				bool flag10 = add != string.Empty;
				if (flag10)
				{
					value += add;
				}
				else
				{
					value += Regex.Replace(part, "amp;", string.Empty);
				}
			});
			bool flag = !string.IsNullOrEmpty(action.Replace);
			if (flag)
			{
				List<string> replaces = action.Replace.Split(new char[]
				{
					';'
				}).ToList<string>();
				replaces.ForEach(delegate(string replace)
				{
					string[] r = replace.Split(new char[]
					{
						','
					});
					value = Regex.Replace(value, r[0], r[1]);
				});
			}
			string a = value.Substring(0, Math.Min(value.Length, action.MaxLength));
			return (action.MaxLength > 0) ? value.Substring(0, Math.Min(value.Length, action.MaxLength)) : value;
		}

		// Token: 0x06000275 RID: 629 RVA: 0x0000A9A0 File Offset: 0x00008BA0
		private DateTime getBusinessDay(DateTime dateTime, int day)
		{
			DateTime currentDay = dateTime;
			bool flag = day >= 0;
			if (flag)
			{
				List<DateTime> dates = Shift.getDaysWithInterval(currentDay, 30, true);
				currentDay = dates[day];
			}
			else
			{
				int count = 0;
				while (count > day)
				{
					currentDay = currentDay.AddDays(-1.0);
					bool flag2 = Shift.isDuringTheWeek(currentDay);
					if (flag2)
					{
						count--;
					}
				}
			}
			return currentDay;
		}

		// Token: 0x040000F5 RID: 245
		private static Browser instance;

		// Token: 0x040000F6 RID: 246
		private WebBrowser browser;

		// Token: 0x040000F7 RID: 247
		private bool wait = false;

		// Token: 0x040000F8 RID: 248
		private Thread main;

		// Token: 0x040000F9 RID: 249
		private bool terminate = false;

		// Token: 0x040000FA RID: 250
		private Origin source;

		// Token: 0x040000FB RID: 251
		private Dictionary<string, string> dictionaryValues;

		// Token: 0x040000FC RID: 252
		private List<List<Element>> searchElements;

		// Token: 0x040000FD RID: 253
		public Activity Activity;
	}
}
