﻿using System;
using System.Collections.Generic;
using System.Linq;
using ZionExtractor;
using ZionRobot.Models.Items;
using ZionSchematics;
using ZionVault.Binder.OCR;
using ZionVault.Binder.Output;

namespace ZionRobot.Tasks
{
	// Token: 0x02000015 RID: 21
	internal class Extractor
	{
		// Token: 0x1700001B RID: 27
		// (get) Token: 0x06000075 RID: 117 RVA: 0x000050F8 File Offset: 0x000032F8
		public bool Running
		{
			get
			{
				return this.running;
			}
		}

		// Token: 0x06000076 RID: 118 RVA: 0x00005100 File Offset: 0x00003300
		public Extractor()
		{
			this.running = false;
			this.extractor = new Analyzer();
		}

		// Token: 0x06000077 RID: 119 RVA: 0x0000511C File Offset: 0x0000331C
		public void Execute(File file, List<Schematics> blueprints)
		{
			this.running = true;
			int count = 1;
			using (ZionVault.Binder.OCR.Document ocr = new ZionVault.Binder.OCR.Document(file.OCR, false))
			{
				using (ZionVault.Binder.Output.Document metadata = new ZionVault.Binder.Output.Document())
				{
					int index = 1;
					ocr.Pages.ForEach(delegate(ZionVault.Binder.OCR.Page page)
					{
						foreach (Schematics bprt in blueprints)
						{
							ZionVault.Binder.Output.Page content = this.extractor.Apply(bprt, page);
							bool flag = content == null;
							if (!flag)
							{
								metadata.Pages.Add(content);
								break;
							}
						}
						bool flag2 = (from p in metadata.Pages
						where p.Index == page.Index
						select p).FirstOrDefault<ZionVault.Binder.Output.Page>() == null;
						if (flag2)
						{
							ZionVault.Binder.Output.Page data = new ZionVault.Binder.Output.Page
							{
								Index = page.Index,
								Type = "UNKWON"
							};
							metadata.Pages.Add(data);
						}
						int index;
						metadata.Pages.Last<ZionVault.Binder.Output.Page>().Index = index;
						index = index;
						index++;
						count += metadata.Pages.Count<ZionVault.Binder.Output.Page>();
					});
					metadata.Status = "INTEGRATION";
					metadata.Save(file.META, false, false);
				}
			}
			file.Status = "INTEGRATION";
			this.running = false;
		}

		// Token: 0x04000022 RID: 34
		private bool running;

		// Token: 0x04000023 RID: 35
		private Analyzer extractor;
	}
}
