﻿using System;
using System.Collections.Generic;
using System.Xml;

namespace ZionRobot.Models.Search
{
	// Token: 0x02000030 RID: 48
	public class Result : XmlDocument, IDisposable
	{
		// Token: 0x17000088 RID: 136
		// (get) Token: 0x06000165 RID: 357 RVA: 0x00008664 File Offset: 0x00006864
		public XmlNode Root { get; }

		// Token: 0x06000166 RID: 358 RVA: 0x0000866C File Offset: 0x0000686C
		public void Dispose()
		{
			bool flag = this.Elements != null;
			if (flag)
			{
				foreach (Element e in this.Elements)
				{
					e.Dispose();
				}
			}
			GC.SuppressFinalize(this);
		}

		// Token: 0x06000167 RID: 359 RVA: 0x000086D8 File Offset: 0x000068D8
		public Result()
		{
			this.Elements = new List<Element>();
		}

		// Token: 0x06000168 RID: 360 RVA: 0x000086F0 File Offset: 0x000068F0
		public Result(string xmlPath)
		{
			this.Load(xmlPath);
			this.Elements = new List<Element>();
			foreach (object obj in this.GetElementsByTagName("Element"))
			{
				XmlElement element = (XmlElement)obj;
				this.Elements.Add(new Element(element));
			}
		}

		// Token: 0x06000169 RID: 361 RVA: 0x00008778 File Offset: 0x00006978
		public override void Save(string path)
		{
			this.AppendChild(this.CreateXmlDeclaration("1.0", "UTF-8", "yes"));
			this.root = base.CreateElement("SearchResult");
			this.Elements.ForEach(delegate(Element element)
			{
				this.root.AppendChild(element.AppendTo(this));
			});
			this.AppendChild(this.root);
			base.Save(path);
		}

		// Token: 0x04000086 RID: 134
		private XmlNode root;

		// Token: 0x04000088 RID: 136
		public List<Element> Elements;
	}
}
