﻿using System;
using System.Collections.Generic;
using System.Linq;
using ZionExtractor;
using ZionRobot.Models.Items;
using ZionSchematics;
using ZionVault.Binder.OCR;
using ZionVault.Binder.Output;

namespace ZionRobot.Tasks
{
	// Token: 0x0200001D RID: 29
	internal class Extractor
	{
		// Token: 0x1700002D RID: 45
		// (get) Token: 0x060000A7 RID: 167 RVA: 0x00005CF4 File Offset: 0x00003EF4
		public bool Running
		{
			get
			{
				return this.running;
			}
		}

		// Token: 0x060000A8 RID: 168 RVA: 0x00005CFC File Offset: 0x00003EFC
		public Extractor()
		{
			this.running = false;
			this.extractor = new Analyzer();
		}

		// Token: 0x060000A9 RID: 169 RVA: 0x00005D18 File Offset: 0x00003F18
		public void Execute(File file, List<Schematics> blueprints)
		{
			this.running = true;
			int count = 1;
			using (ZionVault.Binder.OCR.Document ocr = new ZionVault.Binder.OCR.Document(file.OCR, false))
			{
				using (ZionVault.Binder.Output.Document metadata = new ZionVault.Binder.Output.Document())
				{
					int index = 1;
					ocr.Pages.ForEach(delegate(ZionVault.Binder.OCR.Page page)
					{
						foreach (Schematics bprt in blueprints)
						{
							ZionVault.Binder.Output.Page content = this.extractor.Apply(bprt, page);
							bool flag = content == null;
							if (!flag)
							{
								metadata.Pages.Add(content);
								break;
							}
						}
						bool flag2 = (from p in metadata.Pages
						where p.Index == page.Index
						select p).FirstOrDefault<ZionVault.Binder.Output.Page>() == null;
						if (flag2)
						{
							ZionVault.Binder.Output.Page data = new ZionVault.Binder.Output.Page
							{
								Index = page.Index,
								Type = "UNKWON"
							};
							metadata.Pages.Add(data);
						}
						int index;
						metadata.Pages.Last<ZionVault.Binder.Output.Page>().Index = index;
						index = index;
						index++;
						count += metadata.Pages.Count<ZionVault.Binder.Output.Page>();
					});
					metadata.Status = "INTEGRATION";
					metadata.Save(file.META, false, false);
				}
			}
			file.Status = "INTEGRATION";
			this.running = false;
		}

		// Token: 0x04000034 RID: 52
		private bool running;

		// Token: 0x04000035 RID: 53
		private Analyzer extractor;
	}
}
