﻿using System.Collections.Generic;
using System.Linq;

namespace ZionExtractor.Controllers.LegworkFilters
{
    class Title
    {
        /// <summary>
        /// Retorna um campo baseado em seu nome completo.
        /// </summary>
        /// <param name="fields">Lista de campos do documento.</param>
        /// <param name="fullName">Nome completo do campo desejado.</param>
        /// <param name="found">Retornar apenas se o campo foi encontrado.</param>
        /// <returns>Objeto do tipo Oracle.App.Documents.Fields</returns>
        public static ZionVault.Binder.Output.Field Go(List<ZionVault.Binder.Output.Field> fields, string fullName, bool found)
        {
            return (from ZionVault.Binder.Output.Field field in fields
                    where field.FullName == fullName
                    && ((found && field.isFound) || !found)
                    select field).FirstOrDefault();
        }
    }
}
